package sequoia.path.translation;

import junit.framework.TestCase;

public class TranslatorTest extends TestCase
{
    public void testGetTranslatableSequenceEnd()
    {
        assertEquals(0, Translator.getTranslatableSequenceEnd("", 0));
        assertEquals(0, Translator.getTranslatableSequenceEnd("", 1));
        assertEquals(0, Translator.getTranslatableSequenceEnd("", 2));
        assertEquals(0, Translator.getTranslatableSequenceEnd("1", 0));
        assertEquals(1, Translator.getTranslatableSequenceEnd("1", 1));
        assertEquals(1, Translator.getTranslatableSequenceEnd("1", 2));
        assertEquals(0, Translator.getTranslatableSequenceEnd("12", 0));
        assertEquals(1, Translator.getTranslatableSequenceEnd("12", 1));
        assertEquals(2, Translator.getTranslatableSequenceEnd("12", 2));
        assertEquals(3, Translator.getTranslatableSequenceEnd("123", 0));
        assertEquals(1, Translator.getTranslatableSequenceEnd("123", 1));
        assertEquals(2, Translator.getTranslatableSequenceEnd("123", 2));
        assertEquals(3, Translator.getTranslatableSequenceEnd("1234", 0));
        assertEquals(4, Translator.getTranslatableSequenceEnd("1234", 1));
        assertEquals(2, Translator.getTranslatableSequenceEnd("1234", 2));
        assertEquals(3, Translator.getTranslatableSequenceEnd("12345", 0));
        assertEquals(4, Translator.getTranslatableSequenceEnd("12345", 1));
        assertEquals(5, Translator.getTranslatableSequenceEnd("12345", 2));
        assertEquals(6, Translator.getTranslatableSequenceEnd("123456", 0));
        assertEquals(4, Translator.getTranslatableSequenceEnd("123456", 1));
        assertEquals(5, Translator.getTranslatableSequenceEnd("123456", 2));
        assertEquals(6, Translator.getTranslatableSequenceEnd("1234567", 0));
        assertEquals(7, Translator.getTranslatableSequenceEnd("1234567", 1));
        assertEquals(5, Translator.getTranslatableSequenceEnd("1234567", 2));
    }

    public void testTranslate()
    {
        assertEquals("", Translator.translate("", 0));
        assertEquals("", Translator.translate("", 1));
        assertEquals("", Translator.translate("A", 0));
        assertEquals("", Translator.translate("A", 1));
        assertEquals("", Translator.translate("A", 2));
        assertEquals("", Translator.translate("AA", 0));
        assertEquals("", Translator.translate("AA", 1));
        assertEquals("", Translator.translate("AA", 2));
        assertEquals("MMM", Translator.translate("ATGATGATG", 0));
        assertEquals("MMM", Translator.translate("ATGATGATGA", 0));
        assertEquals("MMM", Translator.translate("ATGATGATGAT", 0));
        assertEquals("MMM", Translator.translate("AATGATGATG", 1));
        assertEquals("MMM", Translator.translate("AATGATGATGA", 1));
        assertEquals("MMM", Translator.translate("AATGATGATGAT", 1));
        assertEquals("MMM", Translator.translate("AAATGATGATG", 2));
        assertEquals("MMM", Translator.translate("AAATGATGATGA", 2));
        assertEquals("MMM", Translator.translate("AAATGATGATGAT", 2));
    }
}
